const pkg = require('../package.json')

module.exports = {
  name: '3CX TAPI',
  namespace: 'http://cp-solutions.at',
  version: pkg.version,
  author: pkg.author,
  copyright: 'Copyright 2021 CP Solutions GmbH',
  source: pkg.repository.url,
  downloadURL: 'https://source.cp-austria.at/git/CPATRD/3cx_tapi/raw/branch/master/3CX_TAPI.user.js',
  match: [
    'https://192.168.0.154:5001/*',
    'https://cpsolution.my3cx.at:5001/*'
  ],
  require: [
    'https://cdn.jsdelivr.net/gh/CoeJoder/waitForKeyElements.js@v1.2/waitForKeyElements.js',
    `https://cdn.jsdelivr.net/npm/axios@${pkg.dependencies.axios}/dist/axios.min.js`,
    `https://cdn.jsdelivr.net/npm/axios-userscript-adapter@${pkg.dependencies['axios-userscript-adapter']}/dist/axiosGmxhrAdapter.min.js`
  ],
  grant: [
    'GM.xmlHttpRequest',
    'GM.notification',
    'GM.getValue',
    'GM.setValue'
  ],
  connect: [
    'cpatapi.cpsrvweb2016.cp-austria.at'
  ],
  'run-at': 'document-end'
}
